'+--------------------------------------------------------------------------+
'|                                                                          |
'|                               DreamWork                                  |
'|                                                                          |
'|                            GDImage project                               |
'|                                                                          |
'|              With exclusive Skin Engine for VISTA and XP                 |
'|                       pushing the Windows limit.                         |
'|                                                                          |
'|                                                                          |
'+--------------------------------------------------------------------------+
'|                                                                          |
'|                         Author Patrice TERRIER                           |
'|                            copyright(c) 2008                             |
'|                           www.zapsolution.com                            |
'|                        pterrier@zapsolution.com                          |
'|                                                                          |
'|  If you are not a registered user of GDImage, then you are not allowed   |
'|  to produce derivated work or any translation of this code to another    |
'|  language, without the written permission of the author.                 |
'|                                                                          |
'+--------------------------------------------------------------------------+
'|                  Project started on : 12-07-2008 (MM-DD-YYYY)            |
'|                        Last revised : 12-24-2008 (MM-DD-YYYY)            |
'+--------------------------------------------------------------------------+

#COMPILE EXE "DreamWork.exe"
'#OPTIMIZE SIZE
'#OPTIMIZE SPEED

#RESOURCE "control.pbr"

'// Return the SKIN Author's name
DECLARE FUNCTION SK_AUTHOR() AS STRING
'// Return SKIN color set
DECLARE FUNCTION SK_ACTIVECAPTION() AS LONG       '// COLOR ACTIVE CAPTION
DECLARE FUNCTION SK_INACTIVECAPTION() AS LONG     '// COLOR INACTIVE CAPTION
DECLARE FUNCTION SK_TEXTCOLOR() AS LONG           '// COLOR TEXT
DECLARE FUNCTION SK_BTNTEXTCOLOR() AS LONG        '// COLOR BUTTON TEXT
DECLARE FUNCTION SK_POPMENUTEXT() AS LONG         '// COLOR POPUP MENU TEXT
DECLARE FUNCTION SK_POPMENUHILITE() AS LONG       '// COLOR POPUP MENU HILIGHTED TEXT
DECLARE FUNCTION SK_ACTIVEMENUBAR() AS LONG       '// COLOR MENU BAR HILIGHTED ITEM
DECLARE FUNCTION SK_INACTIVEMENUBAR() AS LONG     '// COLOR MENU BAR DEFAULT COLOR
DECLARE FUNCTION SK_CAPTIONFONT() AS STRING       '// CAPTION FONT TO USE
DECLARE FUNCTION SK_CAPTIONFONTHEIGHT() AS LONG   '// CAPTION FONT SIZE
DECLARE FUNCTION SK_PUSHBUTFONTSIZE() AS LONG     '// PUSH BUTTON FONT SIZE
DECLARE FUNCTION SK_TRACKHICOLOR() AS LONG        '// TRACK BAR HIGHLIGHTED VALUE
DECLARE FUNCTION SK_TEXTFONT() AS STRING          '// TEXT FONT TO USE
DECLARE FUNCTION SK_AEROEMULATE() AS LONG         '// CHECK IF AERO EMULATION IS ON
DECLARE FUNCTION SK_AEROBLURLEVEL() AS LONG       '// AERO BLURING LEVEL
DECLARE FUNCTION SK_AEROCOLOR() AS LONG           '// AERO GLASS COLOR
DECLARE FUNCTION SK_AEROTIMERDELAY() AS LONG      '// AERO TIMER REFRESH DELAY
DECLARE FUNCTION SK_COLORLABEL() AS STRING        '// GDIPLUS COLOR LIST FOR COLORPICKER COMBO
DECLARE FUNCTION SK_PROGRESSCOLOR() AS LONG       '// TRACK BAR PROGRESS COLOR
DECLARE FUNCTION SK_CENTERFORM() AS STRING        '// DEFAULT FORM BACKGROUND IMAGE

'//DECLARE SUB skDebug LIB "SKENGINE.DLL" (BYVAL Msg$)

#INCLUDE "ZSKIN.INC"

#INCLUDE "GDIMAGE.INC"

'------------------------------------------------------------------------------------------
' LOCAL section
'------------------------------------------------------------------------------------------
%XMIN_SIZE = 800
%YMIN_SIZE = 600

%ID_GDIMAGE             = 9
%ID_FRAMEBUTTON         = 10
%ID_BTN_RESET           = 12

%ID_LIB_ROTATION        = 15
%ID_TRACK_ROTATION      = 16

%ID_BACK_LIST           = 36

%ID_BTN_ABOUT           = 37
%ID_STATUSBAR           = 38
%ID_STATUSTIP           = 39

%ID_BTN_BACKL           = 42
%ID_BTN_BACKR           = 43
%ID_THUMBCTRL           = 44
%ID_LIB_BACK            = 45

%ID_BTN_HELP            = 46

%ID_COMPOSITED          = 47
%ID_BTN_SAVE            = 48
%ID_STATUSMESSAGE       = 49
%ID_BTN_CROP            = 50

%ID_CLOCK               = 54


%FRAME_SizeX = 32'24'128'256'512'588 '// The animation frame width
%FRAME_SizeY = 32'24'128'256'512'440 '// The animation frame height
%TIMER_DELAY = 200'160'160'80'40  '// The timer delay (animation speed)

GLOBAL gMainWnd AS DWORD
GLOBAL gnUseBack, ghGLDC, ghGLRC, ghMemDC, ghBmp AS LONG
GLOBAL mt() AS ZGLTEXTUREX

'// Main entry point
FUNCTION WINMAIN (BYVAL hInstance     AS LONG, _
                  BYVAL hPrevInstance AS LONG, _
                  BYVAL lpCmdLine     AS ASCIIZ PTR, _
                  BYVAL iCmdShow      AS LONG) AS LONG

    LOCAL Msg         AS tagMsg
    LOCAL wc          AS WndClassEx
    LOCAL zClass      AS ASCIIZ * 80
    LOCAL dwExStyle   AS DWORD
    LOCAL dwStyle     AS DWORD
    LOCAL rc          AS RECT
    LOCAL x           AS LONG
    LOCAL y           AS LONG
    LOCAL hMutex      AS DWORD
    LOCAL hFound      AS DWORD
'
    LOCAL hWinXP_Lib           AS LONG ' Handle to WinXP Theme DLL
    LOCAL hWinXP_IsThemeActive AS LONG ' Handle to WinXP's IsThemeActive function
    LOCAL IsInitialized        AS LONG
    LOCAL hGDIplus             AS LONG ' GDIPLUS

    zClass = "ZDREAM"
'
    hMutex = CreateMutex(BYVAL %Null, 0, zClass)
    IF hMutex THEN
       IF GetLastError = %ERROR_ALREADY_EXISTS THEN
          DO
             hFound = FindWindow(zClass, ""): IF hFound THEN EXIT DO
             WHILE PeekMessage(Msg, %NULL, %NULL, %NULL, %PM_REMOVE): WEND
          LOOP
          IF IsIconic(hFound) THEN CALL ShowWindow(hFound, %SW_RESTORE)
          CALL SetForeGroundWindow(hFound)
          FUNCTION = 0
          EXIT FUNCTION
       END IF
    END IF

    CALL zSplitN(zExeName(), "", MyTitle$)
    MyTitle$ = PARSE$(MyTitle$, ".", 1)
'   // Check first for a valid OS version (at least XP)
    IF zOsVersion < 501 THEN
       MsgBox zSysErrorMessage(197),,MyTitle$
       EXIT FUNCTION
    END IF

    wc.cbSize = SIZEOF(wc)
    IsInitialized = GetClassInfoEx(zsInstance(), zClass, wc)
    IF IsInitialized    = 0 THEN
       wc.cbSize        = SIZEOF(wc)
       wc.style         = %CS_HREDRAW OR %CS_VREDRAW OR %CS_DBLCLKS ' OR %CS_DROPSHADOW
       wc.lpfnWndProc   = CODEPTR(WndProc)
       wc.cbClsExtra    = 0
       wc.cbWndExtra    = %EXTEND_EXTRA * 4
       wc.hInstance     = zsInstance()
       wc.hIcon         = LoadIcon(wc.hInstance, "PROGRAM")
       wc.hCursor       = LoadCursor(%NULL, BYVAL %IDC_ARROW)
       wc.hbrBackground = %NULL
       wc.lpszMenuName  = %NULL
       wc.lpszClassName = VARPTR(zClass)
       wc.hIconSm       = wc.hIcon
       IF RegisterClassEx(wc) THEN IsInitialized = %TRUE
    END IF
'
    IF IsInitialized THEN

     '************************************************************************************
     ' Load the GDImage.dll
       IF RegisterGDImageClass() = 0 THEN
          FUNCTION = 99:  EXIT FUNCTION ' If it fails to register then return ERROR = 99
       END IF
     '************************************************************************************

     ' Load the WinXP Theme support (if applicable)
       hWinXP_Lib = LoadLibrary("UxTheme.dll")
       IF hWinXP_Lib THEN
          hWinXP_IsThemeActive = GetProcAddress(hWinXP_Lib, "IsThemeActive")
       END IF
'
       CALL InitCommonControls
'
'      // Init GDIPLUS
       hGDIplus = zGdipStart()

     ' Window Extended Style
       dwExStyle = 0
     ' Windows Style, avoid using %WS_CLIPSIBLINGS OR %WS_CLIPCHILDREN with the Skin Engine
       dwStyle = %WS_POPUP ' OR %WS_CLIPCHILDREN OR %WS_CLIPSIBLINGS
'
       CALL SetRect(rc, 0, 0, %XMIN_SIZE, %YMIN_SIZE)
'      // Note: indeed we don't need AdjustWindowRectEx, because we use do not use a non-client area
'      // but it won't hurt anything to keep it, in case we change our mind ;)
       CALL AdjustWindowRectEx(rc, dwStyle, %FALSE, dwExStyle)  ' Adjust Window To True Requested Size
'
       x = MAX&((GetSystemMetrics(%SM_CXSCREEN) - rc.nRight - rc.nLeft) \ 2, 0)
       y = MAX&((GetSystemMetrics(%SM_CYSCREEN) - rc.nBottom - rc.nTop) \ 2, 0)
'
     ' Create The Window
       MyTitle$ = EXE.Name$
       gMainWnd = CreateWindowEx(dwExStyle, _         ' Extended Style For The Window
                              zClass, _               ' Class Name
                              (MyTitle$), _           ' Window Title
                              dwStyle, _              ' Defined Window Style
                              x, y, _                 ' Window Position
                              rc.nRight - rc.nLeft, _ ' Calculate Window Width
                              rc.nBottom - rc.nTop, _ ' Calculate Window Height
                              %NULL, _                ' No Parent Window
                              %NULL, _                ' No Menu
                              wc.hInstance, _         ' Instance
                              BYVAL %NULL)            ' Dont Pass Anything To WM_CREATE
'
       IF gMainWnd THEN

          CALL ColorInit()
       
          IF (dwExStyle AND %WS_EX_LAYERED) THEN
             CALL SetLayeredWindowAttributes(gMainWnd, RGB(255,0,255), 255, %LWA_ALPHA OR %LWA_COLORKEY)
          END IF

        ' Apply WinXP Theme support
          LOCAL lRes AS LONG, pProc AS DWORD
          IF hWinXP_IsThemeActive THEN
             CALL DWORD hWinXP_IsThemeActive USING IsThemeActive TO lRes
             IF lRes  THEN pProc = GetProcAddress(lRes, "EnableThemeDialogTexture")
             IF pProc THEN CALL DWORD pProc USING EnableDialogTheme(gMainWnd, &H01 OR &H02 OR &H04 OR &H06)
          END IF

'         // Load SKIN components and create SYS buttons
          CALL zInitSkin(gMainWnd, zsExePath() + "DreamWorkSkin.zsk")

'         // Add the child controls being used by the application
          CALL AddChildControls()

'/////////////////////////////////////////////////////////////////////////////////////////
'         // The OpenGL stuff
          CALL CreateGLcontext(%FRAME_SizeX, %FRAME_SizeY, ghGLDC, ghGLRC)
          DIM mt(0 TO 8) AS ZGLTEXTUREX
          'DIM mt(1 TO 2) AS ZGLTEXTURE
          'mt(1).FullName = EXE.Path$ + "infrared.jpg": mt(1).ID = 1: mt(1).Square = 0
          mt(1).FullName = EXE.Path$ + "Background\Fahrenheit451.jpg": mt(1).ID = 1: mt(1).Square = 0
          mt(2).FullName = EXE.Path$ + "Background\Volute.jpg":        mt(2).ID = 2: mt(2).Square = 0
          mt(3).FullName = EXE.Path$ + "Background\volcano.jpg":       mt(4).ID = 3: mt(3).Square = 0
          mt(4).FullName = EXE.Path$ + "Background\Galaxy.jpg": mt(4).ID = 4: mt(4).Square = 0
          mt(5).FullName = EXE.Path$ + "Background\Flower.jpg": mt(5).ID = 5: mt(5).Square = 0
          mt(6).FullName = EXE.Path$ + "Background\OS X Leopard.jpg": mt(6).ID = 6: mt(6).Square = 0
          mt(7).FullName = EXE.Path$ + "Background\Puff.jpg": mt(7).ID = 7: mt(7).Square = 0
          mt(8).FullName = EXE.Path$ + "Background\Tknot.jpg": mt(8).ID = 8: mt(8).Square = 0

          mt(0).FullName = SK_FOLDER() + "flare0.jpg":  mt(0).ID = 2: mt(0).Square = 0

          CALL ZI_MakeMultipleTexture (BYVAL VARPTR(mt(LBOUND(mt))), UBOUND(mt) - LBOUND(mt) + 1)

          gnUseBack = 1: CALL DisplayBackgroundName()
'/////////////////////////////////////////////////////////////////////////////////////////

'         // *************************************************
'         // Show main window
'         // Create region and paint controls to double buffer
'         // *************************************************
          CALL zShowMainWindow(0)

          CALL SetTimer(gMainWnd, 1, %TIMER_DELAY, %NULL)
          WHILE GetMessage(Msg, %NULL, 0, 0)  ' SK_MILLISECOND
             IF IsDialogMessage(gMainWnd, Msg) = %FALSE THEN
                CALL TranslateMessage(Msg)
                CALL DispatchMessage(Msg)
             END IF
          WEND
          CALL KillTimer(gMainWnd, 1)

'/////////////////////////////////////////////////////////////////////////////////////////
          '//FreeUp resources
          IF ghBmp THEN
             CALL DeleteObject(ghBmp)
             CALL DeleteDC(ghMemDC)
          END IF
          CALL DestroyGLresources(ghGLDC, ghGLRC)
'/////////////////////////////////////////////////////////////////////////////////////////


          FUNCTION = msg.wParam
       END IF

'      // UNLOAD the WinXP Theme DLL (if necessary)
       IF hWinXP_Lib THEN CALL FreeLibrary(hWinXP_Lib)

'      // UNLOAD GDIPLUS
       CALL zGdipEnd(hGDIplus)

    END IF
'
    IF hMutex THEN CALL CloseHandle(hMutex)
'
END FUNCTION

'// Add child controls to main window
SUB AddChildControls()

    LOCAL hCtrl, imgW, imgH AS LONG
    LOCAL cAlpha, Red, Green, Blue AS BYTE
    LOCAL sLabel, sImageName AS STRING
    LOCAL zClass AS ASCIIZ * 16
    LOCAL vgW, vgH AS LONG

'   Use the same font for both Aero and Standard mode
    CALL zTEXTRENDERING(%TextRenderingHintAntiAlias, 1)

    hCtrl = zFrameButton(gMainWnd, (SK_FOLDER() + "GDImage.png"), "", 594, 40, 194, 81, %ID_GDIMAGE, 0)
    CALL zSetAnchorMode(hCtrl, %ANCHOR_RIGHT)
    CALL zSetZorder(hCtrl, %HWND_BOTTOM)

    hCtrl = zFrameButton(gMainWnd, (SK_FOLDER() + "Aero.png"), "", 627, 122, 158, 399, %ID_FRAMEBUTTON, 0)
    CALL zSetAnchorMode(hCtrl, %ANCHOR_RIGHT)
    CALL zSetZorder(hCtrl, %HWND_BOTTOM)
'   ___________________

    sLabel = "Animation speed"
    hCtrl = zStaticLabelEx(gMainWnd, (sLabel), 633, 378, 140, 15, %ID_LIB_ROTATION, SK_BTNTEXTCOLOR(), %BS_LABEL_LEFT, 1)
    CALL zSetZorder(hCtrl, %HWND_TOP)
    CALL zSetAnchorMode(hCtrl, %ANCHOR_RIGHT)
    hCtrl = zTrackbarEx(gMainWnd, (SK_FOLDER() + "BTN_Track.png"), 636, 391, 140, 14, %ID_TRACK_ROTATION, 0, 400, 25, SK_TRACKHICOLOR(), SK_PROGRESSCOLOR())
    CALL zSetAnchorMode(hCtrl, %ANCHOR_RIGHT)
    CALL zSetZorder(hCtrl, %HWND_TOP)
    CALL zCreateToolTip(hCtrl, "Adjust speed rotation")

    hCtrl = zButImage(gMainWnd, (SK_FOLDER() + "BTN_Rotate.png"), 376, 518, %ID_BTN_RESET, 0)
    'CALL zGetImageSize(zGetButImageBackProperty(hCtrl), imgW, imgH): imgW = imgW \ 5
    CALL zSetAnchorMode(hCtrl, %ANCHOR_CENTER_HORZ_BOTTOM)
    CALL zSetZorder(hCtrl, %HWND_TOP)
    CALL zCreateToolTip(hCtrl, "Reset")

    hCtrl = zButImage(gMainWnd, (SK_FOLDER() + "BTN_Left.png"), 321, 530, %ID_BTN_BACKL, 0)
    'CALL zGetImageSize(zGetButImageBackProperty(hCtrl), imgW, imgH): imgW = imgW \ 5
    CALL zSetAnchorMode(hCtrl, %ANCHOR_CENTER_HORZ_BOTTOM)
    CALL zSetZorder(hCtrl, %HWND_TOP)
    CALL zCreateToolTip(hCtrl, "Previous background")

    hCtrl = zButImage(gMainWnd, (SK_FOLDER() + "BTN_Right.png"), 425, 530, %ID_BTN_BACKR, 0)
    'CALL zGetImageSize(zGetButImageBackProperty(hCtrl), imgW, imgH): imgW = imgW \ 5
    CALL zSetAnchorMode(hCtrl, %ANCHOR_CENTER_HORZ_BOTTOM)
    CALL zSetZorder(hCtrl, %HWND_TOP)
    CALL zCreateToolTip(hCtrl, "Next background")

    hCtrl = zClockCtrl(gMainWnd, (SK_FOLDER() + "SmallClock.png"), 660, 160, 0, 0, %ID_CLOCK, &H7FCB0000, &H7FFFFF00, %DISABLE_TIMER)
    CALL zSetAnchorMode(hCtrl, %ANCHOR_RIGHT)
    CALL zSetZorder(hCtrl, %HWND_TOP)
    CALL zCreateToolTip(hCtrl, "This is a zClockCtrl")

'   // Change default LED's anchor mode from top right to top center
    CALL zSetAnchorMode(GetDlgItem(gMainWnd, %ID_LED), %ANCHOR_RIGHT)
    CALL zSetZorder(GetDlgItem(gMainWnd, %ID_LED), %HWND_TOP)

    hCtrl = zButImage(gMainWnd, (SK_FOLDER() + "BTN_Help.png"), 5, 4, %ID_BTN_HELP, 0)
    CALL zSetZorder(hCtrl, %HWND_TOP)
    CALL zCreateToolTip(hCtrl, "About")

    hCtrl = zPushButton(gMainWnd, (SK_FOLDER() + "BTN_About.png"), "", 662, 561, 90, 16, %ID_BTN_ABOUT, SK_BTNTEXTCOLOR(), -1, 0)
    CALL zSetAnchorMode(hCtrl, %ANCHOR_BOTTOM_RIGHT)
    CALL zSetZorder(hCtrl, %HWND_BOTTOM)
    CALL zCreateToolTip(hCtrl, "Copyright (c) " + RIGHT$(DATE$, 4) + " Patrice Terrier")

    '// GDImage control
    Style& = %WS_CHILD OR %WS_VISIBLE OR %WS_BORDER
    StyleEx& = 0
    hCtrl = CreateWindowEx(StyleEx&, _
                       $GDImageClassName, _     ' GDImage class name
                       "", _                    ' Optional full path name to picture
                       Style&, _                ' window style
                       662, _                   ' initial x position
                       424, _                   ' initial y position
                       87, _                    ' Calculate Window Width
                       66, _                    ' Calculate Window Height
                       gMainWnd, _              ' parent window handle
                       %ID_THUMBCTRL, _         ' ControlID
                       zInstance, _             ' program instance handle
                       BYVAL 0)                 ' creation parameters
    CALL zCreateToolTip(hCtrl, "GDImage graphic control")
    CALL ZI_SetProperty(hCtrl, %ZI_FitToWindow, 1)
    CALL zSetZorder(hCtrl, %HWND_TOP)
    CALL zSetAnchorMode(hCtrl, %ANCHOR_RIGHT)

    hCtrl = zStaticLabelEx(gMainWnd, "", 634, 494, 144, 18, %ID_LIB_BACK, SK_BTNTEXTCOLOR(), %BS_LABEL_CENTER, 1)
    CALL zSetZorder(hCtrl, %HWND_TOP)
    CALL zSetAnchorMode(hCtrl, %ANCHOR_RIGHT)

    sImageName = SK_FOLDER() + "StatusBar.png"
    CALL ZI_GetImageSizeFromFile((sImageName), imgW, imgH)
    hCtrl = zFrameButton(gMainWnd, (sImageName), "", 0, %YMIN_SIZE - imgH, %XMIN_SIZE, imgH, %ID_STATUSBAR, 0)
    CALL zSetAnchorMode(hCtrl, %ANCHOR_BOTTOM_WIDTH)
    CALL zSetZorder(hCtrl, %HWND_BOTTOM)

    sImageName = SK_FOLDER() + "Tip.png"
    CALL ZI_GetImageSizeFromFile((sImageName), imgW, imgH)
    hCtrl = zFrameButton(gMainWnd, (sImageName), "", 6, %YMIN_SIZE - imgH - 1, imgW, imgH, %ID_STATUSTIP, 0)
    CALL ShowWindow(hCtrl, %SW_HIDE)
    CALL zSetAnchorMode(hCtrl, %ANCHOR_BOTTOM)
    CALL zSetZorder(hCtrl, %HWND_BOTTOM)
    hCtrl = zStaticLabelEx(gMainWnd, "", 26, %YMIN_SIZE - 19, %XMIN_SIZE - 45, 15, %ID_STATUSMESSAGE, SK_BTNTEXTCOLOR(), %BS_LABEL_LEFT, -1)
    CALL zSetZorder(hCtrl, %HWND_TOP)
    CALL zSetAnchorMode(hCtrl, %ANCHOR_BOTTOM_WIDTH)

END SUB

SUB ResizeWindow(BYVAL hWnd AS LONG, BYVAL ChangeBackground AS LONG)
    IF zComposited() THEN lRes& = zBeginDeferWindowPos(hWnd, 0)
    CALL zDrawBackground()
    CALL EnumChildWindows(hWnd, CODEPTR(AnchorEnum), lRes&)
    IF zComposited() THEN CALL zEndDeferWindowPos(hWnd, lRes&)

    IF ChangeBackground THEN
       CALL zUpdateWindow(hWnd, 0)
    END IF
END SUB

SUB DisplayBackgroundName()
    LOCAL sDataString AS STRING
    CALL ZI_SetFromFile(GetDlgItem(gMainWnd, %ID_THUMBCTRL), mt(gnUseBack).FullName)
    CALL zSplitN(mt(gnUseBack).FullName, "", sDataString): sDataString = MCASE$(EXTRACT$(sDataString, $Dot))
    CALL zSetCTLText(zGetMainItem(%ID_LIB_BACK), (sDataString))
END SUB

'// Main window procedure
FUNCTION WndProc(BYVAL hWnd AS LONG, BYVAL Msg AS LONG, BYVAL wParam AS LONG, BYVAL lParam AS LONG) EXPORT AS LONG
    LOCAL ps AS PAINTSTRUCT
    LOCAL rc AS RECT, p AS POINTAPI
    LOCAL nRet, hDC, nFilesDropped, hList, nItem, Img, DoIt AS LONG
    LOCAL szFileName AS ASCIIZ * %MAX_PATH
    LOCAL cAlpha, Red, Green, Blue AS BYTE
    LOCAL sDataString AS STRING

    IF IsWindowVisible(zGetMainItem(%ID_STATUSTIP)) THEN
       IF ZI_IsLButtonDown() = 0 THEN CALL ShowTip(%FALSE)
    END IF

    SELECT CASE LONG Msg

    CASE %WM_GETMINMAXINFO
         LOCAL pMM AS MINMAXINFO PTR
         pMM = lParam
         @pMM.ptMinTrackSize.x = zMinTrackSizeX(0)
         @pMM.ptMinTrackSize.y = zMinTrackSizeY(0)

    CASE %WM_COMMAND
         IF zButtonSysCommand(hWnd, wParam) THEN FUNCTION = 0: EXIT FUNCTION

         SELECT CASE LONG LO(INTEGER, wParam)

         CASE %ID_TRACK_ROTATION
              CALL DisplayMessageTip()
      
         CASE %ID_BTN_RESET
              gnUseBack = 1
              CALL DisplayBackgroundName()
              CALL zSetTrackValue(zGetMainItem(%ID_TRACK_ROTATION), 25)'gnWasAngle)

         CASE %ID_BTN_BACKL
              gnUseBack -= 1: IF gnUseBack < 1 THEN gnUseBack = UBOUND(mt()) 
              CALL DisplayBackgroundName()

         CASE %ID_BTN_BACKR
              gnUseBack += 1: IF gnUseBack > UBOUND(mt()) THEN gnUseBack = 1
              CALL DisplayBackgroundName()

         CASE %ID_BTN_About
              CALL ShellExecute(BYVAL %NULL, "open", "http://www.zapsolution.com", "", "", %SW_SHOW)
              FUNCTION = 0: EXIT FUNCTION

         CASE %ID_BTN_HELP

         END SELECT
         IF GetFocus <> hWnd THEN CALL SetFocus(hWnd)

    CASE %WM_SIZE
         CALL ResizeWindow(hWnd, 0)

    CASE %WM_SETTEXT
'        // Windows please do your job first.
         FUNCTION = DefWindowProc(hWnd, Msg, wParam, lParam)
'        // Update caption
         CALL zPaintBackground(0)
'        // Repaint only the caption.
         CALL GetClientRect(hWnd, rc)
         CALL zGetImageSize(zGetProperty(hWnd, %FORM_TopMid), 0, rc.nBottom)
         CALL InvalidateRect(hWnd, rc, 0)
         CALL UpdateWindow(hWnd)
         EXIT FUNCTION

    CASE %WM_NCLBUTTONDBLCLK
         IF IsIconic(hWnd) = 0 THEN
            LOCAL CaptionHeight AS LONG
            p.X = LO(INTEGER, lParam): p.Y = HI(INTEGER, lParam)
            CALL ScreenToClient(hWnd, p)
            CALL zGetImageSize(zGetProperty(hWnd, %FORM_TopMid), 0, CaptionHeight)
            IF p.Y < CaptionHeight THEN
               IF IsZoomed(hWnd) THEN
                  CALL zButtonSysCommand(hWnd, MAKLNG(%ID_RESTORE, 0))
               ELSE
                  CALL zButtonSysCommand(hWnd, MAKLNG(%ID_MAXIMIZE, 0))
               END IF
               FUNCTION = 0: EXIT FUNCTION
            END IF
         END IF

    CASE %WM_NCACTIVATE
         LOCAL hBut AS LONG
         hBut = GetDlgItem(hWnd, %ID_LED)
         IF hBut THEN
'           // Windows please do your job first.
            FUNCTION = DefWindowProc(hWnd, Msg, wParam, lParam)
            IF zMainWindow(0) = GetForegroundWindow THEN
               gColorCaption = SK_ACTIVECAPTION()
            ELSE
               gColorCaption = SK_INACTIVECAPTION()
            END IF
'           // Update caption
            CALL zPaintBackground(0)

'           // Repaint only the caption.
            CALL GetClientRect(hWnd, rc)
            CALL zGetImageSize(zGetProperty(hWnd, %FORM_TopMid), 0, rc.nBottom)
            CALL InvalidateRect(hWnd, rc, 0)
            CALL UpdateWindow(hWnd)

            EXIT FUNCTION
         END IF

    CASE %WM_ERASEBKGND
         FUNCTION = 1: EXIT FUNCTION

    CASE %WM_PAINT
         BeginPaint(hWnd, ps)
         CALL zPaintDoubleBuffer(hWnd, ps.hDC)
         CALL EndPaint(hWnd, ps)
         FUNCTION = 0: EXIT FUNCTION

    CASE %WM_DESTROY

'        // Remove all image resource from memory
'        // Must be done just before to exit the main program in case zAddResource
'        // has been used to store image handles that are not tied to a specific control.
'        // For example: Image used in an ownerdrawn menu.
         CALL zRemoveAllImageResource()

'        // Delete Image, Bitmap and DC matching this window
         CALL zDestroyWindowResource(hWnd)

         CALL PostQuitMessage(0)
         FUNCTION = 0: EXIT FUNCTION

    CASE %WM_TIMER
         CALL RenderBackground(hWnd)

    END SELECT

    FUNCTION = zDefWindowProc(hWnd, Msg, wParam, lParam)

END FUNCTION

SUB ShowTip(BYVAL bShowHide AS LONG)
    LOCAL nUseState AS LONG, sMessage AS STRING
    IF bShowHide THEN
       nUseState = %SW_SHOW 
       sMessage = "TIP: clic with the right mouse button to restore the default value while hover a slider."
    ELSE 
       nUseState = %SW_HIDE
       sMessage = ""
    END IF 
    CALL ShowWindow(zGetMainItem(%ID_STATUSTIP), nUseState)
    CALL zSetCTLText(zGetMainItem(%ID_STATUSMESSAGE), (sMessage))
END SUB

SUB DisplayMessageTip()
    IF ZI_IsLButtonDown() AND IsWindowVisible(zGetMainItem(%ID_STATUSTIP)) = 0 THEN CALL ShowTip(%TRUE)
END SUB

'////////////////////////
%AC_SRC_OVER                                    = &H00
%AC_SRC_ALPHA                                   = &H01

%GL_TRUE                                        = 1
%GL_FALSE                                       = 0
%GL_LEQUAL                                      = &H0203
%GL_DEPTH_TEST                                  = &H0B71
%GL_SMOOTH                                      = &H1D01
%GL_PROJECTION                                  = &H1701
%GL_TEXTURE_2D                                  = &H0DE1
%GL_BLEND                                       = &H0BE2
%GL_SRC_ALPHA                                   = &H0302
%GL_ONE_MINUS_SRC_ALPHA                         = &H0303
%GL_DEPTH_BUFFER_BIT                            = &H00000100
%GL_COLOR_BUFFER_BIT                            = &H00004000
%GL_QUADS                                       = &H0007
%GL_TEXTURE_MAG_FILTER                          = &H2800
%GL_TEXTURE_MIN_FILTER                          = &H2801
%GL_LINEAR                                      = &H2601
%GL_RGBA                                        = &H1908
%GL_UNSIGNED_BYTE                               = &H1401

%GLU_SMOOTH                                     = 100000

%PFD_TYPE_RGBA                                  = 0
%PFD_DOUBLEBUFFER                               = &H00000001
%PFD_DRAW_TO_WINDOW                             = &H00000004
%PFD_DRAW_TO_BITMAP                             = &H00000008
%PFD_SUPPORT_OPENGL                             = &H00000020
%PFD_SUPPORT_GDI                                = &H00000010

%OBJ_BITMAP                                     = 7

TYPE PIXELFORMATDESCRIPTOR
    nSize AS WORD
    nVersion AS WORD
    dwFlags AS DWORD
    iPixelType AS BYTE
    cColorBits AS BYTE
    cRedBits AS BYTE
    cRedShift AS BYTE
    cGreenBits AS BYTE
    cGreenShift AS BYTE
    cBlueBits AS BYTE
    cBlueShift AS BYTE
    cAlphaBits AS BYTE
    cAlphaShift AS BYTE
    cAccumBits AS BYTE
    cAccumRedBits AS BYTE
    cAccumGreenBits AS BYTE
    cAccumBlueBits AS BYTE
    cAccumAlphaBits AS BYTE
    cDepthBits AS BYTE
    cStencilBits AS BYTE
    cAuxBuffers AS BYTE
    iLayerType AS BYTE
    bReserved AS BYTE
    dwLayerMask AS DWORD
    dwVisibleMask AS DWORD
    dwDamageMask AS DWORD
END TYPE

TYPE BLENDFUNCTION
    BlendOp AS BYTE
    BlendFlags AS BYTE
    SourceConstantAlpha AS BYTE
    AlphaFormat AS BYTE
END TYPE

DECLARE FUNCTION ChoosePixelFormat LIB "GDI32.DLL" ALIAS "ChoosePixelFormat" (BYVAL hDC AS DWORD, pPixelFormatDescriptor AS PIXELFORMATDESCRIPTOR) AS LONG
DECLARE FUNCTION SetPixelFormat LIB "GDI32.DLL" ALIAS "SetPixelFormat" (BYVAL hDC AS DWORD, BYVAL n AS LONG, pcPixelFormatDescriptor AS PIXELFORMATDESCRIPTOR) AS LONG
DECLARE FUNCTION wglCreateContext LIB "OPENGL32.DLL" ALIAS "wglCreateContext" (BYVAL hdc AS DWORD) AS DWORD
DECLARE FUNCTION wglDeleteContext LIB "OPENGL32.DLL" ALIAS "wglDeleteContext" (BYVAL hglrc AS DWORD) AS LONG
DECLARE FUNCTION wglMakeCurrent LIB "OPENGL32.DLL" ALIAS "wglMakeCurrent" (BYVAL hdc AS DWORD, BYVAL hglrc AS DWORD) AS LONG
DECLARE SUB glClear LIB "opengl32.dll" ALIAS "glClear" (BYVAL mask AS DWORD)
DECLARE SUB glClearColor LIB "opengl32.dll" ALIAS "glClearColor" (BYVAL red AS SINGLE, BYVAL green AS SINGLE, BYVAL blue AS SINGLE, BYVAL alpha AS SINGLE)
DECLARE SUB glClearDepth LIB "opengl32.dll" ALIAS "glClearDepth" (BYVAL depth AS DOUBLE)
DECLARE SUB glDepthFunc LIB "opengl32.dll" ALIAS "glDepthFunc" (BYVAL func AS DWORD)
DECLARE SUB glEnable LIB "opengl32.dll" ALIAS "glEnable" (BYVAL cap AS DWORD)
DECLARE SUB glShadeModel LIB "opengl32.dll" ALIAS "glShadeModel" (BYVAL mode AS DWORD)
DECLARE SUB glMatrixMode LIB "opengl32.dll" ALIAS "glMatrixMode" (BYVAL mode AS DWORD)
DECLARE SUB glViewport LIB "opengl32.dll" ALIAS "glViewport" (BYVAL x&, BYVAL y&, BYVAL nwidth&, BYVAL height&)
DECLARE SUB glBlendFunc LIB "opengl32.dll" ALIAS "glBlendFunc" (BYVAL sfactor AS DWORD, BYVAL dfactor AS DWORD)

DECLARE FUNCTION glGetError LIB "opengl32.dll" ALIAS "glGetError" () AS DWORD
DECLARE FUNCTION gluNewQuadric  LIB "glu32.dll" ALIAS "gluNewQuadric"  () AS LONG
DECLARE FUNCTION GetCurrentObject LIB "GDI32.DLL" ALIAS "GetCurrentObject" (BYVAL hdc AS DWORD, BYVAL uObjectType AS DWORD) AS DWORD

DECLARE SUB gluCylinder LIB "GLU32.DLL" ALIAS "gluCylinder" (BYVAL DWORD, BYVAL DOUBLE, BYVAL DOUBLE, BYVAL DOUBLE, BYVAL LONG, BYVAL LONG)
DECLARE SUB gluDisk LIB "GLU32.DLL" ALIAS "gluDisk" (BYVAL DWORD, BYVAL DOUBLE, BYVAL DOUBLE, BYVAL LONG, BYVAL LONG)
DECLARE SUB gluPartialDisk LIB "GLU32.DLL" ALIAS "gluPartialDisk" (BYVAL DWORD, BYVAL DOUBLE, BYVAL DOUBLE, BYVAL LONG, BYVAL LONG, BYVAL DOUBLE, BYVAL DOUBLE)
DECLARE SUB gluSphere LIB "GLU32.DLL" ALIAS "gluSphere" (BYVAL DWORD, BYVAL DOUBLE, BYVAL LONG, BYVAL LONG)
 
DECLARE FUNCTION gluNewQuadric  LIB "glu32.dll" ALIAS "gluNewQuadric"  () AS LONG
DECLARE SUB gluDeleteQuadric    LIB "glu32.dll" ALIAS "gluDeleteQuadric"   (BYVAL state AS DWORD)
DECLARE SUB gluQuadricNormals   LIB "glu32.dll" ALIAS "gluQuadricNormals"  (BYVAL quadObject AS DWORD, BYVAL normals AS DWORD)
DECLARE SUB gluQuadricTexture   LIB "glu32.dll" ALIAS "gluQuadricTexture"  (BYVAL quadObject AS DWORD, BYVAL textureCoords AS DWORD)' ANY)

DECLARE SUB gluLookAt      LIB "glu32.dll" ALIAS "gluLookAt" (BYVAL eyex#, BYVAL eyey#, BYVAL eyez#, BYVAL centerx#, BYVAL centery#, BYVAL centerz#, BYVAL upx#, BYVAL upy#, BYVAL upz AS DOUBLE)
DECLARE SUB gluPerspective LIB "glu32.dll" ALIAS "gluPerspective" (BYVAL fovy#, BYVAL aspect#, BYVAL zNear#, BYVAL zFar AS DOUBLE)
DECLARE SUB glVertex3f LIB "opengl32.dll" ALIAS "glVertex3f" (BYVAL x AS SINGLE, BYVAL y AS SINGLE, BYVAL z AS SINGLE)
DECLARE SUB glViewport LIB "opengl32.dll" ALIAS "glViewport" (BYVAL x&, BYVAL y&, BYVAL nwidth&, BYVAL height&)
DECLARE SUB glClearColor LIB "opengl32.dll" ALIAS "glClearColor" (BYVAL red AS SINGLE, BYVAL green AS SINGLE, BYVAL blue AS SINGLE, BYVAL alpha AS SINGLE)
DECLARE SUB glLoadIdentity LIB "opengl32.dll" ALIAS "glLoadIdentity" ()
DECLARE SUB glTranslatef LIB "opengl32.dll" ALIAS "glTranslatef" (BYVAL x AS SINGLE, BYVAL y AS SINGLE, BYVAL z AS SINGLE)
DECLARE SUB glRotatef LIB "opengl32.dll" ALIAS "glRotatef" (BYVAL angle AS SINGLE, BYVAL x AS SINGLE, BYVAL y AS SINGLE, BYVAL z AS SINGLE)
DECLARE SUB glColor4ub LIB "opengl32.dll" ALIAS "glColor4ub" (BYVAL red AS BYTE, BYVAL green AS BYTE, BYVAL blue AS BYTE, BYVAL alpha AS BYTE)
DECLARE SUB glBindTexture LIB "opengl32.dll" ALIAS "glBindTexture" (BYVAL ntarget AS DWORD, BYVAL texture AS DWORD)
DECLARE SUB glBegin LIB "opengl32.dll" ALIAS "glBegin" (BYVAL mode AS DWORD)
DECLARE SUB glTexCoord2f LIB "opengl32.dll" ALIAS "glTexCoord2f" (BYVAL s AS SINGLE, BYVAL t AS SINGLE)
DECLARE SUB glEnd LIB "opengl32.dll" ALIAS "glEnd" ()
DECLARE SUB glDeleteTextures LIB "opengl32.dll" ALIAS "glDeleteTextures" (BYVAL n&, textures AS ANY)
DECLARE SUB glGenTextures LIB "opengl32.dll" ALIAS "glGenTextures" (BYVAL n&, textures AS ANY)
DECLARE SUB glTexParameteri LIB "opengl32.dll" ALIAS "glTexParameteri" (BYVAL ntarget AS DWORD, BYVAL pname AS DWORD, BYVAL param&)
DECLARE SUB glTexImage2D LIB "opengl32.dll" ALIAS "glTexImage2D" (BYVAL ntarget AS DWORD, BYVAL level&, BYVAL internalformat&, BYVAL nwidth&, BYVAL height&, BYVAL border&, BYVAL format AS DWORD, BYVAL ntype AS DWORD, npixels AS ANY)
DECLARE SUB glNormal3f LIB "OPENGL32.DLL" ALIAS "glNormal3f" (BYVAL SINGLE, BYVAL SINGLE, BYVAL SINGLE)
DECLARE SUB glPushMatrix LIB "OPENGL32.DLL" ALIAS "glPushMatrix" ()
DECLARE SUB glPopMatrix LIB "OPENGL32.DLL" ALIAS "glPopMatrix" ()

DECLARE FUNCTION GetDIBits LIB "GDI32.DLL" ALIAS "GetDIBits" (BYVAL hdc AS DWORD, BYVAL hBitmap AS DWORD, BYVAL nStartScan AS DWORD, BYVAL nNumScans AS DWORD, lpBits AS ANY, lpBI AS MYBITMAPINFO, BYVAL wUsage AS DWORD) AS LONG
DECLARE FUNCTION AlphaBlend LIB "MSIMG32.DLL" ALIAS "AlphaBlend" (BYVAL DWORD, BYVAL LONG, BYVAL LONG, BYVAL LONG, BYVAL LONG, BYVAL DWORD, BYVAL LONG, BYVAL LONG, BYVAL LONG, BYVAL LONG, BYVAL bf AS BLENDFUNCTION) AS LONG
DECLARE FUNCTION GdipBitmapGetPixel LIB "gdiplus.dll" ALIAS "GdipBitmapGetPixel" (BYVAL nBitmap&, BYVAL x&, BYVAL y&, Colr&) AS LONG

FUNCTION zSetupPixelFormat(BYVAL hDC AS LONG) AS LONG
    LOCAL pfd AS PIXELFORMATDESCRIPTOR
    LOCAL pixelformat AS LONG
    LOCAL lRet AS LONG

    lRet = %TRUE

    pfd.nSize      = SIZEOF(pfd)
    pfd.nVersion   = 1
    'pfd.dwFlags    = %PFD_DRAW_TO_WINDOW OR %PFD_SUPPORT_OPENGL OR %PFD_DOUBLEBUFFER OR %PFD_SUPPORT_GDI' This is BassBox setup
    pfd.dwFlags    = %PFD_SUPPORT_OPENGL OR %PFD_SUPPORT_GDI 'This is the default DreamWork setup
    pfd.iPixelType = %PFD_TYPE_RGBA

    pfd.cColorBits = 32
    pfd.cDepthBits = 32

    pixelformat = ChoosePixelFormat(hDC, pfd)

    IF pixelformat THEN
       IF SetPixelFormat(hDC, pixelformat, pfd) = 0 THEN lRet = %FALSE
    ELSE
       lRet = %FALSE
    END IF

    FUNCTION = lRet
END FUNCTION

SUB CreateGLcontext(BYVAL nWidth AS LONG, BYVAL nHeight AS LONG, BYREF ghGLDC AS LONG, BYREF ghGLRC AS LONG)
    LOCAL DesktopDC, hGLBMP AS LONG
    IF nWidth > 0 AND nHeight > 0 THEN
       DesktopDC = GetDC(0)
       ghGLDC = CreateCompatibleDC(DesktopDC)
       hGLBMP = zCreateDIBSection(DesktopDC, nWidth, nHeight, 32)
       CALL SelectObject(ghGLDC, hGLBMP)
       CALL ReleaseDC(0, DesktopDC)
       IF hGLBMP THEN
          IF zSetupPixelFormat(ghGLDC) THEN
            ghGLRC = wglCreateContext(ghGLDC)
            IF ghGLRC THEN
               IF wglMakeCurrent(ghGLDC, ghGLRC) THEN
  
                  CALL glClearColor(0.0, 0.0, 0.0, 0.0)
                  CALL glClearDepth(1.0)
                  CALL glDepthFunc(%GL_LEQUAL)'LESS)'GREATER)'LEQUAL)'ALWAYS)
                  CALL glEnable(%GL_DEPTH_TEST)
                  CALL glShadeModel(%GL_SMOOTH)

                  CALL glMatrixMode(%GL_PROJECTION)

                  CALL glViewport(0, 0, nWidth, nHeight)

                  CALL glEnable(%GL_TEXTURE_2D)

'                 // Use alphablending
                  CALL glEnable(%GL_BLEND)
                  CALL glBlendFunc(%GL_SRC_ALPHA, %GL_ONE_MINUS_SRC_ALPHA)
          
               END IF
            END IF
          END IF
       END IF
    END IF
END SUB

SUB RenderBackground(BYVAL hWnd AS LONG)
    LOCAL rc AS RECT
    LOCAL graphics, DesktopDC, hDeskTop, x, y, hIC, hWndDC, Img AS LONG

    LOCAL bm AS BITMAP, P AS LONG, pBits AS BYTE PTR
  
    CALL GetClientRect(hWnd, rc)
   
    '// Draw active frame to new memory DC
    IF ghBmp = 0 THEN
       hIC = zDisplayDC()
       ghMemDC = CreateCompatibleDC(hIC)
       ghBmp = zCreateDIBSection(hIC, %FRAME_SizeX, %FRAME_SizeY, 32)
       CALL SelectObject(ghMemDC, ghBmp)
       CALL DeleteDC(hIC)
    END IF
    x = (rc.nRight - %FRAME_SizeX) \ 2: y = (rc.nBottom - %FRAME_SizeY) \ 2

'   // Draw the OpenGL scene
    CALL DrawTheScene()
    CALL wglMakeCurrent(ghGLDC, ghGLRC)

    CALL BitBlt(ghMemDC, 0, 0, %FRAME_SizeX, %FRAME_SizeY, ghGLDC, 0, 0, %SRCCOPY)
    CALL GetObject(ghBmp, SIZEOF(bm), bm)
    pBits = bm.bmBits
    FOR P = (bm.bmWidth * bm.bmHeight) TO 1 STEP - 1
           @pBits[3] = 255 'A?
           '@pBits[2] = 0  'R?
           '@pBits[1] = 0  'G?
           '@pBits[0] = 0  'B?
           pBits = pBits + 4
    NEXT


    Img = zBitmapToImage(ghMemDC)
    IF Img THEN
       CALL zDisposeImage(zGetProperty(hWnd, %FORM_Center))
       CALL zSetProperty(hWnd, %FORM_Center, Img)
       CALL InvalidateRect(hWnd, BYVAL 0&, 1)
    END IF

END SUB

SUB DestroyGLresources(BYREF ghGLDC AS LONG, BYREF ghGLRC AS LONG)
    IF ghGLRC THEN
       CALL wglMakeCurrent(ghGLDC, 0)
       CALL wglDeleteContext(ghGLRC): ghGLRC = 0
    END IF
    IF ghGLDC THEN
       CALL DeleteObject(GetCurrentObject(ghGLDC, %OBJ_BITMAP)) ' Delete the memory bitmap
       CALL DeleteDC(ghGLDC): ghGLDC = 0
    END IF
END SUB

SUB DrawFrontFace()
    CALL glBegin(%GL_QUADS)
     ' Front Face
       'CALL glNormal3f(0.0, 0.0, 0.5)
       CALL glTexCoord2f(0.0, 0.0): CALL glVertex3f(-1.0,-1.0, 1.0) ' Bottom Left Of The Texture And Quad
       CALL glTexCoord2f(1.0, 0.0): CALL glVertex3f( 1.0,-1.0, 1.0) ' Bottom Right Of The Texture And Quad
       CALL glTexCoord2f(1.0, 1.0): CALL glVertex3f( 1.0, 1.0, 1.0) ' Top Right Of The Texture And Quad
       CALL glTexCoord2f(0.0, 1.0): CALL glVertex3f(-1.0, 1.0, 1.0) ' Top Left Of The Texture And Quad
    CALL glEnd()
END SUB

GLOBAL gColor() AS LONG
SUB ColorInit()
    DIM gColor(1 TO 33) AS LONG
    gColor(1)  = ZD_ARGB(255,0,32,255)
    gColor(2)  = ZD_ARGB(255,0,57,233)
    gColor(3)  = ZD_ARGB(255,0,67,210)
    gColor(4)  = ZD_ARGB(255,0,89,187)
    gColor(5)  = ZD_ARGB(255,0,112,164)
    gColor(6)  = ZD_ARGB(255,0,135,142)
    gColor(7)  = ZD_ARGB(255,0,159,117)
    gColor(8)  = ZD_ARGB(255,0,183,88)
    gColor(9)  = ZD_ARGB(255,0,207,58)
    gColor(10) = ZD_ARGB(255,0,231,29)
    gColor(11) = ZD_ARGB(255,26,234,26)
    gColor(12) = ZD_ARGB(255,52,237,23)
    gColor(13) = ZD_ARGB(255,79,240,20)
    gColor(14) = ZD_ARGB(255,105,243,17)
    gColor(15) = ZD_ARGB(255,126,245,14)
    gColor(16) = ZD_ARGB(255,147,248,11)
    gColor(17) = ZD_ARGB(255,168,250,8)
    gColor(18) = ZD_ARGB(255,189,253,5)
    gColor(19) = ZD_ARGB(255,210,255,2)
    gColor(20) = ZD_ARGB(255,233,255,0)
    gColor(21) = ZD_ARGB(255,255,255,0)
    gColor(22) = ZD_ARGB(255,255,251,0)
    gColor(23) = ZD_ARGB(255,255,235,0)
    gColor(24) = ZD_ARGB(255,255,215,0)
    gColor(25) = ZD_ARGB(255,255,196,0)
    gColor(26) = ZD_ARGB(255,255,176,0)
    gColor(27) = ZD_ARGB(255,255,156,0)
    gColor(28) = ZD_ARGB(255,253,137,0)
    gColor(29) = ZD_ARGB(255,255,117,0)
    gColor(30) = ZD_ARGB(255,255,97,0)
    gColor(31) = ZD_ARGB(255,255,78,0)
    gColor(32) = ZD_ARGB(255,255,58,0)
    gColor(33) = ZD_ARGB(255,255,32,0)
END SUB

SUB DrawTheScene() ' See MSDN documentation for the use of the OpenGL API

    STATIC xrot, yrot, zrot1, zrot2 AS SINGLE, nStep, nColor AS LONG
    LOCAL zRotStep AS SINGLE
    
    CALL glClearColor(0.0, 0.0, 0.0, 0.0)
    CALL glClear(%GL_COLOR_BUFFER_BIT OR %GL_DEPTH_BUFFER_BIT)
    
   
    CALL glLoadIdentity()
    
    CALL gluPerspective(35.0, 1.0, 1.0, 100.0)

    CALL glTranslatef(0.0, 0.0, -2.5)'-2.45)'-4.0)
    
    CALL glRotatef(zrot1, 0.0, 0.0, 1.0) ' Rotate On The Z Axis


    zRotStep = zGetTrackValue(zGetMainItem(%ID_TRACK_ROTATION)) / 100
    zrot1 += zRotStep

    nColor = ((ABS(zrot1) mod 359) / 11.25)
    nColor += nStep
    IF nColor > 32 THEN
       nStep = -1
    ELSEIF nColor < 1 THEN
       nColor = 1
       nStep = 1
    END IF


    CALL zSplitColorARGB (gColor(nColor), A?, R?, G?, B?) 
    CALL glColor4ub(R?, G?, B?, 255)
    CALL glBindTexture(%GL_TEXTURE_2D, mt(gnUseBack).Texture)
    CALL DrawFrontFace()
 
 
    CALL glRotatef(zrot2, 0.0, 0.0, 1.0)                             ' Rotate On The Z Axis
    zrot2 -= zRotStep * 3

    CALL zSplitColorARGB (gColor(34 - nColor), A?, R?, G?, B?) 
    CALL glColor4ub(R?, G?, B?, 80)
    CALL glBindTexture(%GL_TEXTURE_2D, mt(0).Texture)
    CALL DrawFrontFace()
    
END SUB
